modelderivative/v2/designdata/{urn}/metadata/{modelGuid}/properties:query
Queries the objects in the Model View (Viewable) specified by the modelGuid URI parameter and returns the specified properties in a paginated list. You can limit the number of objects to be queried by specifying a filter using the query attribute in the request body.
Note: A design file must be translated to SVF or SVF2 before you can query object properties.
Before you call this operation:
- Use the List Model Views operation to obtain the list of Model Views in the source design.
- Pick the ID of the Model View you want to query and specify that ID as the value for the
modelGuidURI parameter.
Resource Information
| Method and URI | POST https://developer.api.autodesk.com/modelderivative/v2/designdata/{urn}/metadata/{modelGuid}/properties:query |
| Authentication Context | User context optional |
| Required OAuth Scopes | data:read |
| Data Format | JSON |
Request
Headers
| Authorization* string | Must be Bearer <token>, where <token> is a two-legged access token obtained via a Client Credentials Grant flow, or a three-legged access token obtained via an Authorization Code flow or a Secure Service Account (SSA) flow.
The SSA flow is designed for headless server-to-server operations. While it functions like a two-legged flow (no user interaction), it is classified as three-legged because it preserves user context. |
| Accept-Encoding string | A comma separated list of the algorithms you want the response to be encoded in, specified in the order of preference.
If you specify |
| region string | Specifies the data center where the manifest and derivatives of the specified source design are stored. Possible values are:
|
| x-ads-derivative-format string | Specifies which Object IDs to return if the design has legacy SVF derivatives generated by the BIM Docs or Forma Data Management service. Possible values:
Note:
|
| Content-Type* string | Must be application/json |
Request
URI Parameters
| urn string | The URL-safe Base64 encoded URN of the source design. This value is used as the urn URI parameter in operations to access data for this source design. |
| modelGuid string | The ID of the Model View you are querying. Use the List Model Views operation to obtain the IDs of the Model Views in the source design. |
Request
Body Structure
| pagination* object | Specifies how to split the response into multiple pages, and return the response one page at a time. |
| offset* number | The number of properties to skip. Use this attribute with the limit attribute to split the properties into multiple pages. To fetch the first page, specify offset =0 (do not skip any properties). To fetch the second page, specify offset = value of limit you specified for the first page. So, the server skips the properties returned on the first page. In general, offset = previous_offset + previous_limit. This attribute is 0 by default. The minimum value is 0. |
| limit* number | The maximum number of properties to return in a single page. Use this attribute with the offset attribute to split the properties into multiple pages. To fetch the first page, specify offset =0 (do not skip any properties). To fetch the second page, specify offset = value of limit you specified for the first page. So, the server skips the search results returned on the first page. In general, offset = previous_offset + previous_limit. This attribute is 20 by default. The minimum value is 1 and the maximum is 1000. |
| query* one of | Specifies what objects to query. Contains the parameters to pass to the search service. You can use one of the following forms: |
| Match ID* object | Describes a query for retrieving objects having the specified Object IDs or External IDs. |
| $in array: object | Returns only the objects with their objectid or externalId attribute exactly matching one of the values specified in the array.
The first element of the array contains the name of the attribute to match ( For example, if you specify an array as: |
| Begins With* object | Describes a query for retrieving objects with names that start with a specified string. |
| $prefix array: string | Returns only the objects with their name attribute beginning with the specified string.
The first element of the array contains the name of the attribute to match ( |
| Equals To* object | Describes a query for retrieving objects where a specified attribute exactly matches a specified value. |
| $eq array: object | Returns only the objects where the value of the specified attribute (name attribute or any numerical property) is exactly equal to the specified value.
The first element of the array contains the name of the attribute. This can be the For example, if you specify an array as: Note: We recommend that you use |
| Between* object | Describes a query for retrieving objects where a specified numeric property falls within a specified range. |
| $between array: object | Returns only the objects where the value of the specified numeric property lies between the specified values.
The first element of the array contains the name of the property. The next two elements specify the values that the property must lie between. The array can only be three elements long. For example, if you specify an array as: Note: The Model Derivative service converts numeric values from their native units to metric base units for comparison. So, you must specify the values to compare with in metric base units. For example, if the property you are comparing is a length measurement, you must specify the values in |
| Less Than* object | Describes a query for retrieving objects where a specified numeric property is less than or equal to a specified value. |
| $le array: object | Returns only the objects where the value of the specified numeric property is less than or equal to the specified value.
The first element of the array contains the name of the property. The next element specifies the values that the property must be less than or equal to. The array can only be two elements long. For example, if you specify an array as: Note: The Model Derivative service converts numeric values from their native units to metric base units for comparison. So, the value to compare with must be specified in metric base units. For example, if the property you are comparing is a length measurement, you must specify the value in |
| Greater Than* object | Use this to retrieve only the properties of objects where a specified property is greater than a specified value. |
| $ge array: object | Returns only the objects where the value of the specified numerical property is greater than or equal to the specified value.
The first element of the array contains the name of the property. The next element specifies the values that the property must be greater than or equal to. The array can only be two elements long. For example, if you specify an array as: Note: The Model Derivative service converts numeric values from their native units to metric base units for comparison. So, the value to compare with must be specified in metric base units. For example, if the property you are comparing is a length measurement, you must specify the value in |
| Contains* object | Describes a query for retrieving objects where a specified property contains one or more words in a specified string. |
| $contains array: string | Returns only the objects where the value of the specified property contains the words specified in a string.
The first element of the array contains the name of the property. The second element contains a string containing the words to match. The array can only be two elements long. For example, if you specify an array as: |
| fields* object | Specifies what properties of the objects to return. If you do not specify this attribute, the response returns all properties.
Possible values are:
|
| payload enum:string | Specifies the format for numeric values in the response body. Possible values:
|
Response
HTTP Status Code Summary
| 200 OK | The requested properties were successfully retrieved. |
| 202 Accepted | The request was accepted but processing is not complete. Repeat the request until you receive an HTTP status of 200. |
| 400 Bad Request | The server was unable to process the request. The syntax of the request is malformed or the request is missing a required header. Do not repeat the request without fixing the issue. The response body may indicate what is wrong with the request. |
| 403 Forbidden | Unauthorized |
| 404 Not Found | The requested resource was not found. Review the request and try again. |
| 429 Too Many Requests | The request was rejected because too many requests were sent within a specific time period. Wait before retrying the request. Check the response headers for rate limit information and recommended retry timing. |
| 500 Internal Server Error | An unexpected error occurred on the server, preventing it from completing your request. Please try again later. If the issue persists, contact the support team for assistance. |
Response
Header (200)
| x-ads-app-identifier string | The service identifier. Comprises of the service name, version, and environment. |
| x-ads-startup-time string | The service startup time, in the following date format: EEE MMM dd HH:mm:ss Z yyyy. |
| x-ads-duration string | The amount of time spent servicing the request, in milliseconds. |
| x-ads-troubleshooting string | Provides information about server failures, if any. |
| x-ads-size string | Size in bytes of the request data. Additionally, the system uses this information to determine if a 413 (content too large) response is returned. |
Response
Body Structure (200)
| pagination object | Container for the attributes that define how the response paginated. |
| limit number | The maximum number of properties you requested for this page. |
| offset number | The number of items skipped (because they were returned in previous pages) when returning this page. |
| totalResults number | The total number of properties to be returned. |
| data object | Container for the data returned by the Fetch Specific Properties operation. |
| type string | The type of data that is returned. Always properties. |
| collection array: object | Array of objects with their “properties” as a non-hierarchical list. |
| objectid number | Unique identifier of the object.
Note: The
|
| name string | Name of the object. |
| externalId string | A unique identifier of the object as defined in the source design. For example, UniqueID in Revit files. |
| properties object | A JSON object containing dictionary objects (key value pairs), where the key is the property name and the value is the value of the property. |
Response
Body Structure (202)
Response for 202 has no body.
The following examples return raw HTTP headers and JSON objects. For a more developer-friendly experience, consider using our TypeScript SDK or .NET SDK. Both provide strongly typed data with IntelliSense support, offering code completion, error checking, and tooltips that reduce the need to reference JSON schemas.
Example 1
This example retrieves all properties for two objects (IDs: 4269 and 438). The model is a Revit file translated to SVF/SVF2 format. Note that Revit models have the richest metadata among all Autodesk products.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$in": [
"objectid",
4269,
438
]
},
"fields": [
"objectid",
"name",
"externalId",
"properties.Cons*"
],
"pagination": {
"offset": 0,
"limit": 20
},
"payload": "text"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload with query parameters
const raw = JSON.stringify({
"query": {
"$in": [ // Query objects by objectid
"objectid", // Field to query
4269, // First object ID
438 // Second object ID
]
},
"fields": [ // Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Cons*" // Wildcard to match properties starting with "Cons"
],
"pagination": {
"offset": 0, // Start from first result
"limit": 20 // Return up to 20 results
},
"payload": "text" // Return property values as text
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body with query parameters
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$in\": [\n" + // Query objects by objectid
" \"objectid\",\n" + // Field to query
" 4269,\n" + // First object ID
" 438\n" + // Second object ID
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"objectid\",\n" +
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.Cons*\"\n" + // Wildcard to match properties starting with "Cons"
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 0,\n" + // Start from first result
" \"limit\": 20\n" + // Return up to 20 results
" },\n" +
" \"payload\": \"text\"\n" + // Return property values as text
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload with query parameters
payload = json.dumps({
"query": {
"$in": [ # Query objects by objectid
"objectid", # Field to query
4269, # First object ID
438 # Second object ID
]
},
"fields": [ # Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Cons*" # Wildcard to match properties starting with "Cons"
],
"pagination": {
"offset": 0, # Start from first result
"limit": 20 # Return up to 20 results
},
"payload": "text" # Return property values as text
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 20,
"offset": 0,
"totalResults": 2
},
"data": {
"type": "properties",
"collection": [
{
"objectid": 438,
"name": "Floor [418183]",
"externalId": "d85573c2-f8d5-46ae-966a-ac82fa18f500-00066187",
"properties": {
"Constraints": {
"Level": "Level 2",
"Height Offset From Level": "0.000 mm",
"Room Bounding": "Yes",
"Related to Mass": "No"
},
"Construction": {
"Structure": "",
"Default Thickness": "300.000 mm",
"Function": "Interior"
}
}
},
{
"objectid": 4269,
"name": "Generic 150mm",
"externalId": "e3e052f9-0156-11d5-9301-0000863f27ad-00000153",
"properties": {
"Construction": {
"Structure": "",
"Default Thickness": "150.000 mm",
"Function": "Interior"
}
}
}
]
}
}
Example 2
This example is the same as Example 1, except that the payload request body attribute is set to unit.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$in": [
"objectid",
4269,
438
]
},
"fields": [
"objectid",
"name",
"externalId",
"properties.Cons*"
],
"pagination": {
"offset": 0,
"limit": 20
},
"payload": "unit"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload (same as Example 1 but with "unit" payload)
const raw = JSON.stringify({
"query": {
"$in": [ // Query objects by objectid
"objectid", // Field to query
4269, // First object ID
438 // Second object ID
]
},
"fields": [ // Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Cons*" // Wildcard to match properties starting with "Cons"
],
"pagination": {
"offset": 0, // Start from first result
"limit": 20 // Return up to 20 results
},
"payload": "unit" // Return property values with units
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body (same as Example 1 but with "unit" payload)
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$in\": [\n" + // Query objects by objectid
" \"objectid\",\n" + // Field to query
" 4269,\n" + // First object ID
" 438\n" + // Second object ID
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"objectid\",\n" +
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.Cons*\"\n" + // Wildcard to match properties starting with "Cons"
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 0,\n" + // Start from first result
" \"limit\": 20\n" + // Return up to 20 results
" },\n" +
" \"payload\": \"unit\"\n" + // Return property values with units
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload (same as Example 1 but with "unit" payload)
payload = json.dumps({
"query": {
"$in": [ # Query objects by objectid
"objectid", # Field to query
4269, # First object ID
438 # Second object ID
]
},
"fields": [ # Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Cons*" # Wildcard to match properties starting with "Cons"
],
"pagination": {
"offset": 0, # Start from first result
"limit": 20 # Return up to 20 results
},
"payload": "unit" # Return property values with units
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 20,
"offset": 0,
"totalResults": 2
},
"data": {
"type": "properties",
"collection": [
{
"objectid": 438,
"name": "Floor [418183]",
"externalId": "d85573c2-f8d5-46ae-966a-ac82fa18f500-00066187",
"properties": {
"Constraints": {
"Height Offset From Level": "##0{mm}[1]{m}"
},
"Construction": {
"Default Thickness": "##300{mm}[1]{m}"
}
}
},
{
"objectid": 4269,
"name": "Generic 150mm",
"externalId": "e3e052f9-0156-11d5-9301-0000863f27ad-00000153",
"properties": {
"Construction": {
"Default Thickness": "##150{mm}[1]{m}"
}
}
}
]
}
}
Example 3
This example retrieves only the “Analytical Properties” for objects with the specified external IDs. The model is a Revit file translated to SVF/SVF2 format. Revit models contain the richest metadata among all Autodesk products.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$in": [
"externalId",
"e3e052f9-0156-11d5-9301-0000863f27ad-00000153",
"5e8712a2-e372-44b6-9e73-0aaa430558ee-0008656f"
]
},
"fields": [
"name",
"externalId",
"properties.Analytical Properties"
],
"pagination": {
"offset": 0,
"limit": 20
},
"payload": "text"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload - Query by external IDs
const raw = JSON.stringify({
"query": {
"$in": [ // Query objects by externalId
"externalId", // Field to query
"e3e052f9-0156-11d5-9301-0000863f27ad-00000153", // First external ID
"5e8712a2-e372-44b6-9e73-0aaa430558ee-0008656f" // Second external ID
]
},
"fields": [ // Specify which fields to return
"name",
"externalId",
"properties.Analytical Properties" // Only Analytical Properties
],
"pagination": {
"offset": 0, // Start from first result
"limit": 20 // Return up to 20 results
},
"payload": "text" // Return property values as text
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body - Query by external IDs
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$in\": [\n" + // Query objects by externalId
" \"externalId\",\n" + // Field to query
" \"e3e052f9-0156-11d5-9301-0000863f27ad-00000153\",\n" + // First external ID
" \"5e8712a2-e372-44b6-9e73-0aaa430558ee-0008656f\"\n" + // Second external ID
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.Analytical Properties\"\n" + // Only Analytical Properties
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 0,\n" + // Start from first result
" \"limit\": 20\n" + // Return up to 20 results
" },\n" +
" \"payload\": \"text\"\n" + // Return property values as text
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload - Query by external IDs
payload = json.dumps({
"query": {
"$in": [ # Query objects by externalId
"externalId", # Field to query
"e3e052f9-0156-11d5-9301-0000863f27ad-00000153", # First external ID
"5e8712a2-e372-44b6-9e73-0aaa430558ee-0008656f" # Second external ID
]
},
"fields": [ # Specify which fields to return
"name",
"externalId",
"properties.Analytical Properties" # Only Analytical Properties
],
"pagination": {
"offset": 0, # Start from first result
"limit": 20 # Return up to 20 results
},
"payload": "text" # Return property values as text
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 20,
"offset": 0,
"totalResults": 2
},
"data": {
"type": "properties",
"collection": [
{
"name": "Floor [550255]",
"externalId": "5e8712a2-e372-44b6-9e73-0aaa430558ee-0008656f",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "0.000 watt / (m^2 kelvin)",
"Thermal Resistance (R)": "0.000 m^2 kelvin / watt",
"Thermal mass": "0.000 kjoule / kelvin",
"Absorptance": "0.100",
"Roughness": "1"
}
}
},
{
"name": "Generic 150mm",
"externalId": "e3e052f9-0156-11d5-9301-0000863f27ad-00000153",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "0.000 watt / (m^2 kelvin)",
"Thermal Resistance (R)": "0.000 m^2 kelvin / watt",
"Thermal mass": "0.000 kjoule / kelvin",
"Absorptance": "0.100",
"Roughness": "1"
}
}
}
]
}
}
Example 4
This example retrieves an object by its name and gets all properties in the Construction category. The search string uses lowercase while the actual object name is in title case, demonstrating that the matching is case-insensitive. The model is a Revit file translated to SVF/SVF2 format. Revit models contain the richest metadata among all Autodesk products.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$eq": [
"name",
"timber suspended floor"
]
},
"fields": [
"objectid",
"name",
"externalId",
"properties.Construction.*"
],
"pagination": {
"offset": 0,
"limit": 20
},
"payload": "text"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload - Query by name with $eq operator
const raw = JSON.stringify({
"query": {
"$eq": [ // Uses $eq for exact match (case-insensitive)
"name", // Field to query
"timber suspended floor" // Name to match (case-insensitive)
]
},
"fields": [ // Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Construction.*" // Wildcard for all Construction properties
],
"pagination": {
"offset": 0, // Start from first result
"limit": 20 // Return up to 20 results
},
"payload": "text" // Return property values as text
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body - Query by name with $eq operator
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$eq\": [\n" + // Uses $eq for exact match (case-insensitive)
" \"name\",\n" + // Field to query
" \"timber suspended floor\"\n" + // Name to match (case-insensitive)
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"objectid\",\n" +
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.Construction.*\"\n" + // Wildcard for all Construction properties
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 0,\n" + // Start from first result
" \"limit\": 20\n" + // Return up to 20 results
" },\n" +
" \"payload\": \"text\"\n" + // Return property values as text
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload - Query by name with $eq operator
payload = json.dumps({
"query": {
"$eq": [ # Uses $eq for exact match (case-insensitive)
"name", # Field to query
"timber suspended floor" # Name to match (case-insensitive)
]
},
"fields": [ # Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Construction.*" # Wildcard for all Construction properties
],
"pagination": {
"offset": 0, # Start from first result
"limit": 20 # Return up to 20 results
},
"payload": "text" # Return property values as text
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 20,
"offset": 0,
"totalResults": 1
},
"data": {
"type": "properties",
"collection": [
{
"objectid": 4272,
"name": "Timber Suspended Floor",
"externalId": "203cff26-4c9d-4eb4-93e5-28d28a01f256-0002d338",
"properties": {
"Construction": {
"Structure": "",
"Default Thickness": "247.000 mm",
"Function": "Interior"
}
}
}
]
}
}
Example 5
This example retrieves objects with “Floor” in their name and gets all properties that begin with “type”. The wildcard * is used to return matching properties regardless of their category. The model is a Revit file translated to SVF/SVF2 format. Revit models contain the richest metadata among all Autodesk products.
Note: Objects without the requested properties are shown a {}.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$prefix": [
"name",
"floor"
]
},
"fields": [
"objectid",
"name",
"externalId",
"properties.*.type*"
],
"pagination": {
"offset": 0,
"limit": 20
},
"payload": "text"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload - Query by name prefix with double wildcard
const raw = JSON.stringify({
"query": {
"$prefix": [ // Uses $prefix to find names starting with value
"name", // Field to query
"floor" // Name prefix to match (case-insensitive)
]
},
"fields": [ // Specify which fields to return
"objectid",
"name",
"externalId",
"properties.*.type*" // Double wildcard: any category, properties starting with "type"
],
"pagination": {
"offset": 0, // Start from first result
"limit": 20 // Return up to 20 results
},
"payload": "text" // Return property values as text
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body - Query by name prefix with double wildcard
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$prefix\": [\n" + // Uses $prefix to find names starting with value
" \"name\",\n" + // Field to query
" \"floor\"\n" + // Name prefix to match (case-insensitive)
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"objectid\",\n" +
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.*.type*\"\n" + // Double wildcard: any category, properties starting with "type"
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 0,\n" + // Start from first result
" \"limit\": 20\n" + // Return up to 20 results
" },\n" +
" \"payload\": \"text\"\n" + // Return property values as text
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload - Query by name prefix with double wildcard
payload = json.dumps({
"query": {
"$prefix": [ # Uses $prefix to find names starting with value
"name", # Field to query
"floor" # Name prefix to match (case-insensitive)
]
},
"fields": [ # Specify which fields to return
"objectid",
"name",
"externalId",
"properties.*.type*" # Double wildcard: any category, properties starting with "type"
],
"pagination": {
"offset": 0, # Start from first result
"limit": 20 # Return up to 20 results
},
"payload": "text" # Return property values as text
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 20,
"offset": 0,
"totalResults": 10
},
"data": {
"type": "properties",
"collection": [
{
"objectid": 91,
"name": "Floors",
"externalId": "225f03d8-e034-4a5b-858c-a767fc7a4ff1",
"properties": {}
},
{
"objectid": 169,
"name": "Floor [176804]",
"externalId": "203cff26-4c9d-4eb4-93e5-28d28a01f256-0002b2a4",
"properties": {
"Identity Data": {
"Type Name": "Generic 150mm",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 201,
"name": "Floor [495352]",
"externalId": "17836a3c-e764-47fa-a2e0-08216444f621-00078ef8",
"properties": {
"Identity Data": {
"Type Name": "Concrete-Domestic 425mm",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 207,
"name": "Floor [647908]",
"externalId": "66314231-2860-4f9f-87a8-f581c5b96b2f-0009e2e4",
"properties": {
"Identity Data": {
"Type Name": "Insitu Concrete 225mm",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 438,
"name": "Floor [418183]",
"externalId": "d85573c2-f8d5-46ae-966a-ac82fa18f500-00066187",
"properties": {
"Identity Data": {
"Type Name": "Generic 300",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 487,
"name": "Floor [549031]",
"externalId": "5e8712a2-e372-44b6-9e73-0aaa430558ee-000860a7",
"properties": {
"Identity Data": {
"Type Name": "Generic 300",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 507,
"name": "Floor [764691]",
"externalId": "c82e0dd9-31e8-407e-a294-c30431c2fda3-000bab13",
"properties": {
"Identity Data": {
"Type Name": "Insitu Concrete 225mm",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 589,
"name": "Floor [512683]",
"externalId": "1970f67d-62ee-4fc6-9008-0a9f00762fe0-0007d2ab",
"properties": {
"Identity Data": {
"Type Name": "Timber Suspended Floor",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 590,
"name": "Floor [550255]",
"externalId": "5e8712a2-e372-44b6-9e73-0aaa430558ee-0008656f",
"properties": {
"Identity Data": {
"Type Name": "Generic 150mm",
"Type Image": "",
"Type Comments": "",
"Type Mark": ""
}
}
},
{
"objectid": 4268,
"name": "Floor",
"externalId": "8e458af7-0024-4214-80e0-31b9845333d0",
"properties": {}
}
]
}
}
Example 6
This example retrieves objects that contain the words “SH_Resin” and “Concrete” in their Material and Finishes property. Note that the request specifically asks for the second page of results. The model is a Revit file translated to SVF/SVF2 format. Revit models contain the richest metadata among all Autodesk products.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$contains": [
"properties.Materials and Finishes.Structural Material",
"SH_resin Concrete"
]
},
"fields": [
"objectid",
"name",
"externalId",
"properties.Materials and Finishes"
],
"pagination": {
"offset": 30,
"limit": 30
},
"payload": "text"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload - Query with $contains in nested property path
const raw = JSON.stringify({
"query": {
"$contains": [ // Uses $contains to find text within property
"properties.Materials and Finishes.Structural Material", // Nested property path to search
"SH_resin Concrete" // Text to find
]
},
"fields": [ // Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Materials and Finishes" // Return Materials and Finishes properties
],
"pagination": {
"offset": 30, // **NOTE: Requesting second page (skip first 30)**
"limit": 30 // Return up to 30 results
},
"payload": "text" // Return property values as text
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body - Query with $contains in nested property path
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$contains\": [\n" + // Uses $contains to find text within property
" \"properties.Materials and Finishes.Structural Material\",\n" + // Nested property path to search
" \"SH_resin Concrete\"\n" + // Text to find
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"objectid\",\n" +
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.Materials and Finishes\"\n" + // Return Materials and Finishes properties
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 30,\n" + // **NOTE: Requesting second page (skip first 30)**
" \"limit\": 30\n" + // Return up to 30 results
" },\n" +
" \"payload\": \"text\"\n" + // Return property values as text
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload - Query with $contains in nested property path
payload = json.dumps({
"query": {
"$contains": [ # Uses $contains to find text within property
"properties.Materials and Finishes.Structural Material", # Nested property path to search
"SH_resin Concrete" # Text to find
]
},
"fields": [ # Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Materials and Finishes" # Return Materials and Finishes properties
],
"pagination": {
"offset": 30, # **NOTE: Requesting second page (skip first 30)**
"limit": 30 # Return up to 30 results
},
"payload": "text" # Return property values as text
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 30,
"offset": 30,
"totalResults": 37
},
"data": {
"type": "properties",
"collection": [
{
"objectid": 4269,
"name": "Generic 150mm",
"externalId": "e3e052f9-0156-11d5-9301-0000863f27ad-00000153",
"properties": {
"Materials and Finishes": {
"Structural Material": "SH_resin Floor"
}
}
},
{
"objectid": 4270,
"name": "Generic 300",
"externalId": "9c1f7993-9536-44bd-bedc-bf731228f65b-00072966",
"properties": {
"Materials and Finishes": {
"Structural Material": "SH_resin Floor"
}
}
},
{
"objectid": 4271,
"name": "Concrete-Domestic 425mm",
"externalId": "7f28cee1-b998-4a37-89e2-f58405cbbc56-0008df1d",
"properties": {
"Materials and Finishes": {
"Structural Material": "Concrete, Cast In Situ"
}
}
},
{
"objectid": 4273,
"name": "Insitu Concrete 225mm",
"externalId": "7f28cee1-b998-4a37-89e2-f58405cbbc56-0008defb",
"properties": {
"Materials and Finishes": {
"Structural Material": "Concrete, Cast In Situ"
}
}
},
{
"objectid": 4299,
"name": "Foundation - 300mm Concrete",
"externalId": "7f28cee1-b998-4a37-89e2-f58405cbbc56-0008df7c",
"properties": {
"Materials and Finishes": {
"Structural Material": "Concrete, Cast In Situ"
}
}
},
{
"objectid": 4300,
"name": "Retaining - 300mm Concrete",
"externalId": "1551350c-45e5-41b8-bdf1-bcfa6794dc6a-000adce2",
"properties": {
"Materials and Finishes": {
"Structural Material": "Concrete - Cast In Situ"
}
}
},
{
"objectid": 5264,
"name": "150mm Foundation Slab",
"externalId": "5adccf95-7ef8-4f40-aa7c-dd3dcfd6d307-00015129",
"properties": {
"Materials and Finishes": {
"Structural Material": "Concrete, Cast In Situ"
}
}
}
]
}
}
Example 7
This example queries objects whose Absorptance property is greater than or equal to 0.1. Absorptance is a numeric property with no units. The model is a Revit file translated to SVF/SVF2 format. Revit models contain the richest metadata among all Autodesk products.
Request
curl --location 'https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query' \
--header 'Authorization: Bearer eyJh...' \
--header 'Content-Type: application/json' \
--data '{
"query": {
"$ge": [
"properties.Analytical Properties.Absorptance",
0.1
]
},
"fields": [
"objectid",
"name",
"externalId",
"properties.Analytical Properties"
],
"pagination": {
"offset": 0,
"limit": 20
},
"payload": "unit"
}'
// Define headers for the request
const myHeaders = new Headers();
myHeaders.append("Authorization", "Bearer eyJh..."); // Add authorization token
myHeaders.append("Content-Type", "application/json"); // Specify JSON content type
// Define the request payload - Query with $ge operator on numeric value
const raw = JSON.stringify({
"query": {
"$ge": [ // Uses $ge (greater than or equal) for numeric comparison
"properties.Analytical Properties.Absorptance", // Nested property path with numeric value
0.1 // **NUMERIC VALUE** (not a string)
]
},
"fields": [ // Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Analytical Properties" // Return all Analytical Properties
],
"pagination": {
"offset": 0, // Start from first result
"limit": 20 // Return up to 20 results
},
"payload": "unit" // **Return values with units** (not "text")
});
// Configure the request options
const requestOptions = {
method: "POST", // HTTP method
headers: myHeaders, // Attach headers
body: raw, // Attach request payload
redirect: "follow" // Follow redirects if any
};
// Send the request using the Fetch API
fetch("https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query", requestOptions)
.then((response) => response.text()) // Parse response as text
.then((result) => console.log(result)) // Log the result
.catch((error) => console.error(error)); // Handle errors
// Create a new HttpClient instance
var client = new HttpClient();
// Create a POST request to the specified URL
var request = new HttpRequestMessage(HttpMethod.Post, "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query");
// Add the Authorization header with Bearer token
request.Headers.Add("Authorization", "Bearer eyJh...");
// Define the request body - Query with $ge operator on numeric value
var content = new StringContent(
"{\n" +
" \"query\": {\n" +
" \"$ge\": [\n" + // Uses $ge (greater than or equal) for numeric comparison
" \"properties.Analytical Properties.Absorptance\",\n" + // Nested property path with numeric value
" 0.1\n" + // **NUMERIC VALUE** (not a string)
" ]\n" +
" },\n" +
" \"fields\": [\n" + // Specify which fields to return
" \"objectid\",\n" +
" \"name\",\n" +
" \"externalId\",\n" +
" \"properties.Analytical Properties\"\n" + // Return all Analytical Properties
" ],\n" +
" \"pagination\": {\n" +
" \"offset\": 0,\n" + // Start from first result
" \"limit\": 20\n" + // Return up to 20 results
" },\n" +
" \"payload\": \"unit\"\n" + // **Return values with units** (not "text")
"}", null, "application/json");
// Attach the content to the request
request.Content = content;
// Send the request and await the response
var response = await client.SendAsync(request);
// Ensure the response indicates success
response.EnsureSuccessStatusCode();
// Output the response content
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Import required libraries
import requests
import json
# Define the API endpoint URL
url = "https://developer.api.autodesk.com/modelderivative/v2/designdata/dXJuOmFkc2sub2JqZWN0czpvcy5vYmplY3Q6bW9kZWxfZGVyaXZhdGl2ZV9wcm9wX2VuaGFuY2VtZW50X3Rlc3RpbmcvcmFjX2Jhc2ljX3NhbXBsZV9wcm9qZWN0LnJ2dA/metadata/6bfb4886-f2ee-9ccb-8db0-c5c170220c40/properties:query"
# Define the request payload - Query with $ge operator on numeric value
payload = json.dumps({
"query": {
"$ge": [ # Uses $ge (greater than or equal) for numeric comparison
"properties.Analytical Properties.Absorptance", # Nested property path with numeric value
0.1 # **NUMERIC VALUE** (not a string)
]
},
"fields": [ # Specify which fields to return
"objectid",
"name",
"externalId",
"properties.Analytical Properties" # Return all Analytical Properties
],
"pagination": {
"offset": 0, # Start from first result
"limit": 20 # Return up to 20 results
},
"payload": "unit" # **Return values with units**
})
# Define the request headers
headers = {
'Authorization': 'Bearer eyJh...', # Authorization token
'Content-Type': 'application/json' # Specify JSON content type
}
# Send the POST request to the API
response = requests.request("POST", url, headers=headers, data=payload)
# Print the response content
print(response.text)
Response
{
"pagination": {
"limit": 20,
"offset": 0,
"totalResults": 79
},
"data": {
"type": "properties",
"collection": [
{
"objectid": 169,
"name": "Floor [176804]",
"externalId": "203cff26-4c9d-4eb4-93e5-28d28a01f256-0002b2a4",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 170,
"name": "Basic Wall [198749]",
"externalId": "ef57b02a-5e81-49e7-93bb-ae5f002d921c-0003085d",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 172,
"name": "Basic Wall [418079]",
"externalId": "72678df9-14a3-4aee-a80e-94a8e55a0926-0006611f",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 175,
"name": "Basic Wall [422243]",
"externalId": "59371552-5800-43eb-9ba3-609565158fc5-00067163",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 193,
"name": "Basic Wall [424922]",
"externalId": "59371552-5800-43eb-9ba3-609565158fc5-00067bda",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 195,
"name": "Basic Wall [425745]",
"externalId": "7fcc8dca-3132-4323-9d41-faf5184b4f26-00067f11",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 196,
"name": "Basic Wall [427092]",
"externalId": "c85e5be0-d8d5-4148-836f-b55e711ef373-00068454",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 197,
"name": "Basic Wall [493612]",
"externalId": "17836a3c-e764-47fa-a2e0-08216444f621-0007882c",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.7499999999999999{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.3333333333333335{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##12.673461104640001{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 198,
"name": "Basic Wall [493697]",
"externalId": "17836a3c-e764-47fa-a2e0-08216444f621-00078881",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.7499999999999999{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.3333333333333335{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##12.673461104640001{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 199,
"name": "Basic Wall [493790]",
"externalId": "17836a3c-e764-47fa-a2e0-08216444f621-000788de",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.7499999999999999{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.3333333333333335{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##12.673461104640001{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 200,
"name": "Basic Wall [493879]",
"externalId": "17836a3c-e764-47fa-a2e0-08216444f621-00078937",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##3.486666666666667{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0.28680688336520077{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##42.1157351232{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 201,
"name": "Floor [495352]",
"externalId": "17836a3c-e764-47fa-a2e0-08216444f621-00078ef8",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.6083921894474449{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.6436765910953293{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##31.743853931520004{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 202,
"name": "Pad [523064]",
"externalId": "7cce6b00-0763-4991-acce-01cfe02128f7-0007fb38",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 204,
"name": "Basic Wall [627064]",
"externalId": "5b7ac240-e9a7-43b2-b6bf-246956549a40-00099178",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.7499999999999999{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.3333333333333335{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##12.673461104640001{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 205,
"name": "Basic Wall [627729]",
"externalId": "5b7ac240-e9a7-43b2-b6bf-246956549a40-00099411",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.7499999999999999{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.3333333333333335{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##12.673461104640001{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 206,
"name": "Basic Wall [628523]",
"externalId": "5b7ac240-e9a7-43b2-b6bf-246956549a40-0009972b",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0.7499999999999999{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##1.3333333333333335{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##12.673461104640001{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 207,
"name": "Floor [647908]",
"externalId": "66314231-2860-4f9f-87a8-f581c5b96b2f-0009e2e4",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##4.648888888888889{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0.21510516252390058{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##31.586801342400005{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 218,
"name": "Compound Ceiling [697612]",
"externalId": "f714ef06-3fa3-4b95-b3e7-bbbd1e6eda49-000aa50c",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 271,
"name": "Basic Wall [845266]",
"externalId": "f565bef9-7d27-4781-b8d4-60f4a6034d87-000ce5d2",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
},
{
"objectid": 274,
"name": "Basic Wall [849032]",
"externalId": "98e2f96c-ccbd-4abb-a697-e7e5136106ee-000cf488",
"properties": {
"Analytical Properties": {
"Heat Transfer Coefficient (U)": "##0{watt / (m^2 kelvin)}[4]{kg / (s^3 K)}",
"Thermal Resistance (R)": "##0{m^2 kelvin / watt}[4]{(s^3 K) / kg}",
"Thermal mass": "##0{kjoule / kelvin}[2]{(kg m^2) / (s^2 K)}",
"Absorptance": "##0.1{}[3]{}"
}
}
}
]
}
}